mob/var/learn_focus_train = 0
mob/var/focus_boxing = 0
mob/var/focus_boxing_delay = 0
mob/var/training = ""

mob/learn/verb/Concentrate()
	set category = "Training"

	switch(input("What will you concentrate on?","Concentrate")in list("Powerlevel","Ki","Strength","Defence"))

		if("Powerlevel")
			src.training = "Power"
			src << "You will now concentrate on Powerlevel"
			return
		if("Ki")
			src.training = "Ki"
			src << "You will now concentrate on Ki"
			return
		if("Strength")
			src.training = "Strength"
			src << "You will now concentrate on Strength"
			return
		if("Defence")
			src.training = "Defence"
			src << "You will now concentrate on Defence"
			return

mob/learn/verb/Focus_Train()
	set category = "Training"

	if(!src.training)
		src << "You must choose what to Concentrate on first!"
		return

	if(src.focus_boxing_delay)
		src << "You must wait a moment before Training again!"
		return

	if(src.doing)
		return

	if(src.fatigue >= src.fatigue_max)
		src << "You are too exhausted to Train"
		return

	if(src.focus_boxing)
		src.afk_time = 0
		src.icon_state = ""
		src.focus_boxing = 0
		src.frozen = 0
		src.doing = 0
		src << "You stop training"
		sleep(25)
		src.focus_boxing_delay = 0
		return

	if(src.doing)
		return

	if(!src.focus_boxing)
		src.afk_time = 0
		src.focus_boxing_delay = 1
		src.icon_state = "spar fury"
		src.focus_boxing = 1
		src.doing = 1
		src.frozen = 1
		src << "You begin to train yourself"
		spawn(5) src.focus_box_gain()
		sleep(25)
		src.focus_boxing_delay = 0
		return

mob/proc/focus_box_gain()

	if(src.focus_boxing)
		sleep(10)
		if(src.fatigue >= src.fatigue_max)
			src.fatigue = src.fatigue_max
			src.focus_boxing = 0
			src.frozen = 0
			src.doing = 0
			src.icon_state = ""
			src << "You stumble to your knees and gasp for air..."
			return

		src.fatigue += rand(2,5)

		var/bonus_exp = round(rand(4,10) + src.level)

		for(var/obj/Gravity_Room/Gravity_Control/C in view(24))
			if(C.grav > 0)
				bonus_exp += C.grav / 8

		for(var/obj/Gravity_Room/Guild_Gravity_Control/C2 in view(24))
			if(C2.grav > 0)
				bonus_exp += C2.grav / 6

		if("exp_buff" in src.buffs)
			bonus_exp += bonus_exp * 0.25

		if("minor_exp_buff" in src.buffs)
			bonus_exp += bonus_exp * 0.05

		if(src.training == "Power") src.PWR_EXP += bonus_exp
		if(src.training == "Ki") src.KI_EXP += bonus_exp
		if(src.training == "Strength") src.STR_EXP += bonus_exp
		if(src.training == "Defence") src.DEF_EXP += bonus_exp

		for(var/obj/Gravity_Room/Gravity_Control/C in view(24))
			src.powerlevel -= C.grav / 6
			src.GRAVITYDeath()

		for(var/obj/Gravity_Room/Guild_Gravity_Control/C2 in view(24))
			src.powerlevel -= C2.grav / 6
			src.GRAVITYDeath()

		spawn(5) src.Character_Up()
		spawn(20) src.focus_box_gain()
		return

//-------------------------------------------------------------------------

mob/var/PWR_EXP = 0
mob/var/KI_EXP = 0
mob/var/STR_EXP = 0
mob/var/DEF_EXP = 0

mob/var/PWR_TNL = 15
mob/var/KI_TNL = 15
mob/var/STR_TNL = 15
mob/var/DEF_TNL = 15

mob/var/PWR_LVL = 0
mob/var/KI_LVL = 0
mob/var/STR_LVL = 0
mob/var/DEF_LVL = 0

mob/proc/Character_Up()
	var/pl = round(rand(10,30) + src.powerlevel_max * 0.01)
	var/ki_gain = round(rand(10,30) + src.ki_max * 0.01)
	var/str = round(rand(2,10) + src.strength_max * 0.01)
	var/def = round(rand(2,10) + src.defence_max  * 0.01)

	if(src.training == "Power")
		if(src.PWR_EXP >= src.PWR_TNL)
			src.PWR_LVL ++
			src.powerlevel += pl
			src.powerlevel_max += pl
			src.PWR_EXP = 0
			src.PWR_TNL = (src.PWR_LVL * src.PWR_LVL) * 4
			src << "\white You feel more powerful..."

	if(src.training == "Ki")
		if(src.KI_EXP >= src.KI_TNL)
			src.KI_LVL ++
			src.ki += ki_gain
			src.ki_max += ki_gain
			src.KI_EXP = 0
			src.KI_TNL = (src.KI_LVL * src.KI_LVL) * 4
			src << "\white You feel more energized..."

	if(src.training == "Strength")
		if(src.STR_EXP >= src.STR_TNL)
			src.STR_LVL ++
			src.strength += str
			src.strength_max += str
			src.STR_EXP = 0
			src.STR_TNL = (src.STR_LVL * src.STR_LVL) * 4
			src << "\white You feel stronger..."

	if(src.training == "Defence")
		if(src.DEF_EXP >= src.DEF_TNL)
			src.DEF_LVL ++
			src.defence += def
			src.defence_max += def
			src.DEF_EXP = 0
			src.DEF_TNL = (src.DEF_LVL * src.DEF_LVL) * 4
			src << "\white You feel more durable..."

	return